package org.seasar.javelin;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * Javelin̎sG[̃K[NXB<br>
 * 
 * Singletonp^[păCX^XɐĂB
 * @author eriguchi
 */
public class JavelinErrorLogger
{
    /**
     * sB
     */
    private static final String           NEW_LINE    = System.getProperty("line.separator");

    /**
     * G[Oõ͓tH[}bgB
     */
    private static final SimpleDateFormat DATE_FORMAT = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");

    /**
     * JavelinErrorLogger̃CX^XB
     */
    private static JavelinErrorLogger     instance_   = new JavelinErrorLogger();

    /**
     * G[̏o͐B
     */
    private PrintStream                   errorOut_;

    /**
     * JavelinErrorLoggerCX^X擾p\bhB
     * 
     * @return JavelinErrorLoggerCX^XB
     */
    public static JavelinErrorLogger getInstance()
    {
        return instance_;
    }

    /**
     * G[Ot@CI[vB
     * @param logFileName G[Ot@CB
     * @throws FileNotFoundException G[Ot@CȂꍇB
     */
    public void open(String logFileName)
        throws FileNotFoundException
    {
        if (this.errorOut_ != null)
        {
            this.close();
        }

        // t@Cnull̏ꍇ͉ȂB
        if (logFileName == null)
        {
            return;
        }
        FileOutputStream fileOutputStream = new FileOutputStream(logFileName, true);
        PrintStream logStream = new PrintStream(fileOutputStream);
        this.errorOut_ = logStream;
    }

    /**
     * G[Ot@CN[YB
     */
    public void close()
    {
        if (this.errorOut_ != System.err)
        {
            this.errorOut_.close();
        }
    }

    /**
     * G[Oo͂B
     * @param message G[bZ[WB
     * @param throwable OB
     */
    public void log(String message, Throwable throwable)
    {
        SimpleDateFormat dateFormat = DATE_FORMAT;
        String dateMessage = dateFormat.format(new Date());

        this.errorOut_.print(dateMessage);
        if (message != null)
        {
            this.errorOut_.print(" [Javelin] ");
            this.errorOut_.println(message);
        }
        if (throwable != null)
        {
            StringWriter stringWriter = new StringWriter();
            PrintWriter printWriter = new PrintWriter(stringWriter);

            throwable.printStackTrace(printWriter);
            String stackTrace = stringWriter.toString();
            this.errorOut_.print(stackTrace);
        }
    }

    /**
     * G[Oo͂B
     * @param message G[bZ[WB
     */
    public void log(String message)
    {
        log(message, null);
    }

    /**
     * G[Oo͂B
     * @param throwable OB
     */
    public void log(Throwable throwable)
    {
        log(null, throwable);
    }

    /**
     * RXgN^B
     * CX^X1ɐ邽߁Aprivate\bhƂB
     */
    private JavelinErrorLogger()
    {
        this.errorOut_ = System.err;
    }

    /**
     * G[OB
     * 
     * @param options NIvV
     */
    public static void initErrorLog(S2JavelinConfig config)
    {
        // G[Kt@C擾B
        String errorFileName = config.getErrorLog();

        // G[Ot@Cw肳ĂȂꍇ́AsȂB
        if (errorFileName == null)
        {
            return;
        }

        File errorFile = new File(errorFileName);
        File parent = errorFile.getAbsoluteFile().getParentFile();
        if (parent == null || parent.exists() == false)
        {
            // JavelinsG[o̓t@CfBNg݂ȂꍇAWG[o͂ɃG[o͂A
            // ȍ~̃G[Oo͐WG[o͂ƂB
            logErrorLogNotFound(errorFileName);
        }
        else if (errorFile.exists() == true && errorFile.canWrite() == false)
        {
            // JavelinsG[o̓t@Cւ̏݌ȂꍇAWG[o͂ɃG[o͂A
            // ȍ~̃G[Oo͐WG[o͂ƂB
            logErrorLogCannotWrite(errorFileName);
        }
        else
        {
            try
            {
                // G[Ȍo͐t@CJB
                JavelinErrorLogger.getInstance().open(errorFileName);
            }
            catch (FileNotFoundException fnfe)
            {
                // JavelinsG[o̓t@CfBNg݂ȂꍇAWG[o͂ɃG[o͂A
                // ȍ~̃G[Oo͐WG[o͂ƂB
                logErrorLogNotFound(errorFileName);
            }
        }
    }

    /**
     * JavelinsG[o̓t@Cւ̏݌ȂꍇɁAG[Oo͂sB
     * 
     * @param errorFileName
     *            G[o̓t@CB
     */
    private static void logErrorLogCannotWrite(String errorFileName)
    {
        JavelinErrorLogger.getInstance().log(
                                             "JavelinsG[o̓t@Cւ̏݌܂BWG[o͂gp܂B"
                                                     + NEW_LINE + "(javelin.error.log="
                                                     + errorFileName + ")");
    }

    /**
     * JavelinsG[o̓t@CfBNg݂ȂꍇɁAG[Oo͂sB
     * 
     * @param errorFileName
     *            G[o̓t@CB
     */
    private static void logErrorLogNotFound(String errorFileName)
    {
        JavelinErrorLogger.getInstance().log(
                                             "JavelinsG[o̓t@CfBNg݂܂BWG[o͂gp܂B"
                                                     + NEW_LINE + "(javelin.error.log="
                                                     + errorFileName + ")");
    }

}