package org.seasar.javelin;

import java.io.PrintStream;
import java.lang.reflect.Modifier;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

import org.aopalliance.intercept.MethodInvocation;
import org.seasar.framework.aop.interceptors.AbstractInterceptor;
import org.seasar.framework.log.Logger;

/**
 * JavelinOo͂AComponentԂ̌Ăяo֌W
 * MBeanƂČJ邽߂InterceptorB<br>
 * <br>
 * ܂Aȉ̏AMBeanoRŎ擾邱Ƃ\B
 * <ol>
 * <li>\bȟĂяo</li>
 * <li>\bh̕Ϗԁi~bPʁj</li>
 * <li>\bh̍Œԁi~bPʁj</li>
 * <li>\bh̍ŒZԁi~bPʁj</li>
 * <li>\bȟĂяo</li>
 * <li>O̔</li>
 * <li>O̔</li>
 * </ol>
 * ܂Aȉ̏dicont@Cł̃p[^Ŏw\B
 * <ol>
 * <li>httpPort:HTTPŌJۂ̃|[gԍBgpɂMX4JKvB</li>
 * <li>intervalMax:\bh̏Ԃ񕪋L^邩B
 *     ftHgl1000B</li>
 * <li>throwableMax:O̔񕪋L^邩B
 *     ftHgl1000B</li>
 * <li>recordThreshold:ԋL^p臒lB
 *     ̎Ԃz\bhĂяô݋L^B
 *     ftHgl0B</li>
 * <li>alarmThreshold:ԋL^p臒lB
 *     ̎Ԃz\bhĂяo̔ViwerɒʒmB
 *     ftHgl1000B</li>
 * <li>domain:MBeano^ۂɎgphCB
 *     ۂ̃hĆA[domainp[^] + [Mbean̎]ƂȂB
 *     MBean̎ނ͈ȉ̂̂B
 *     <ol>
 *       <li>container:SR|[lgObjectNameǗB</li>
 *       <li>component:̃R|[lgɊւJMBeanB</li>
 *       <li>invocation:\bhĂяoɊւJMBeanB</li>
 *     </ol>
 *     </li>
 * </ol>
 * 
 * @version 0.2
 * @author On Eriguchi (SMG), Tetsu Hayakawa (SMG)
 */
public class S2JavelinInterceptor extends AbstractInterceptor
{
    private static final long serialVersionUID = 6661781313519708185L;

    /**
     * \bhĂяoJavlinO̐擪ɏo͂鎯ʎqB
     */
    private static final String CALL = "Call  ";

    /**
     * \bh߂莞JavlinO̐擪ɏo͂鎯ʎqB
     */
    private static final String RETURN = "Return";

    /**
     * OthrowJavlinO̐擪ɏo͂鎯ʎqB
     */
    private static final String THROW = "Throw ";

    /**
     * OcatchJavlinO̐擪ɏo͂鎯ʎqB
     */
    private static final String CATCH = "Catch ";

    
    private static final int CALLER_STACKTRACE_INDEX = 3;

    /**
     * sB
     */
    private static final String NEW_LINE = System.getProperty("line.separator");

    /**
     * Ő؂蕶B
     */
    private static final String DELIM = ",";

    /**
     * Xbh̋؂蕶
     */
    private static final String THREAD_DELIM = "@";

    /**
     * Oo͂鎞̃tH[}bgB
     */
    private static final String TIME_FORMAT_STR = "yyyy/MM/dd HH:mm:ss.SSS";

    /**
     * JavelinOɏo͂鎞f[^`ptH[}b^B
     */
    private ThreadLocal<DateFormat> timeFormat_ = new ThreadLocal<DateFormat>()
    {
        protected synchronized DateFormat initialValue()
        {
            return new SimpleDateFormat(TIME_FORMAT_STR);
        }
    };

    /**
     * \bȟĂяoIuWFNg\B
     */
    private ThreadLocal<String> callerLog_ = new ThreadLocal<String>()
    {
        protected synchronized String initialValue()
        {
            return "<unknown>,<unknown>,0";
        }
    };

    /**
     * JavelinOo͗pK[B
     */
    private static Logger logger_ = Logger
            .getLogger(S2JavelinInterceptor.class);

    /**
     * o͂邩ǂB
     * argsvpeB̒lZbgB
     */
    private boolean isLogArgs_ = true;

    /**
     * ߂lo͂邩ǂB
     * returnvpeB̒lZbgB
     */
    private boolean isLogReturn_ = true;

    /**
     * X^bNg[Xo͂邩ǂB
     * stackTracevpeB̒lZbgB
     */
    private boolean isLogStackTrace_ = false;

    /**
     * OL^e[uB
     * L[ɃXbh̎ʎqAlɗOIuWFNgB
     * O炱̃}bvɂ̗Oo^A
     * Lb`ꂽ_ō폜B
     */
    static private Map<String, Throwable> exceptionMap__ = 
    	Collections.synchronizedMap(new HashMap<String, Throwable>());
    
    private S2JavelinConfig config_ = new S2JavelinConfig();

    /** ݒlWo͂ɏo͂true */
    private boolean isPrintConfig_ = false;
    
    /**
     * JavelinOo͗pinvoke\bhB
     * 
     * ۂ̃\bhĂяosOŁA
     * Ăяoƕԋp̏ڍ׃OAJavelin`ŏo͂B
     * sɗOꍇ́ȀڍׂOo͂B<br>
     * 
     * ܂Aۂ̃\bhĂяosOŁA
     * s񐔂sԂMBeanɋL^B
     * 
     * sɗOꍇ́A
     * O̔񐔂┭L^B
     * 
     * @param invocation
     *            C^[Zv^ɂĎ擾ꂽAĂяo\bh̏
     * @return invocationsƂ̖߂l
     * @throws Throwable invocationsƂɔO
     */
    public Object invoke(MethodInvocation invocation) throws Throwable
    {
        // ݒlo͂ĂȂΏo͂
        synchronized (this)
        {
            if (isPrintConfig_ == false)
            {
                isPrintConfig_ = true;
                printConfigValue();
            }
        }

        // Ăяo擾B
        String calleeClassName  = getTargetClass(invocation).getName();
        String calleeMethodName = invocation.getMethod().getName();
        
        try
        {
            // Ăяo擾B
            String className  = calleeClassName;
            String methodName = calleeMethodName;

            StackTraceElement[] stacktrace  = null;
            if (config_.isLogStacktrace())
            {
            	stacktrace = Thread.currentThread().getStackTrace();
            }
            
            JmxRecorder.preProcess(className, methodName, this.config_);
            S2StatsJavelinRecorder.preProcess(className, methodName,
                                              invocation.getArguments(), stacktrace, this.config_);
        }
        catch(Throwable th)
        {
        	th.printStackTrace();
        }
        
        String objectID   = "";
        String threadInfo = "";
        
        StringBuffer methodCallBuff = new StringBuffer(256);
        // Ăяo擾B
        String currentCallerLog = "";

        if (config_.isJavelinEnable())
        {
        	currentCallerLog = (String) this.callerLog_.get();
        	
            objectID = Integer.toHexString(System
                    .identityHashCode(invocation.getThis()));
            String modifiers = Modifier.toString(invocation.getMethod()
                    .getModifiers());

            Thread currentThread   = Thread.currentThread();
            String threadName      = currentThread.getName();
            String threadClassName = currentThread.getClass().getName();
            String threadID        = 
            	Integer.toHexString(System.identityHashCode(currentThread));
            
            threadInfo = 
            	threadName 
            	+ THREAD_DELIM 
            	+ threadClassName 
            	+ THREAD_DELIM 
            	+ threadID;

            // \bhĂяoʕB
            methodCallBuff.append(calleeMethodName);
            methodCallBuff.append(DELIM);
            methodCallBuff.append(calleeClassName);
            methodCallBuff.append(DELIM);
            methodCallBuff.append(objectID);

            // ĂяõOA񃍃Oǒ͎ĂяoƂĎgp邽߂ɕۑB
            this.callerLog_.set(methodCallBuff.toString());

            methodCallBuff.append(DELIM);
            methodCallBuff.append(currentCallerLog);
            methodCallBuff.append(DELIM);
            methodCallBuff.append(modifiers);
            methodCallBuff.append(DELIM);
            methodCallBuff.append(threadInfo);
            methodCallBuff.append(NEW_LINE);

            // Call ڍ׃OB
            StringBuffer callDetailBuff = createCallDetail(methodCallBuff,
                    invocation);

            // Call OóB
            logger_.debug(callDetailBuff);
        }

        //ۂ̃\bhĂяosB
        //sɗOȀڍ׃Oo͂B
        Object ret = null;
        try
        {
            // \bhĂяoB
            ret = invocation.proceed();
        }
        catch (Throwable cause)
        {
            JmxRecorder.postProcess(cause);
            S2StatsJavelinRecorder.postProcess(cause, this.config_);

            if (config_.isJavelinEnable())
            {
                // Throwڍ׃OB
                StringBuffer throwBuff = createThrowCatchDetail(THROW, calleeMethodName,
                        calleeClassName, objectID, threadInfo, cause);

                // Throw OóB
                logger_.debug(throwBuff);

                //OL^B
                exceptionMap__.put(threadInfo, cause);
            }
            
            //OX[AIB
            throw cause;
        }
        
        if (config_.isJavelinEnable())
        {
            //̃XbhŁAOɗOĂmFB
            //ĂĂɂǂ蒅̂ł΁A̎_ŗO
            //catchꂽƂƂɂȂ̂ŁACatchOo͂B
            boolean isExceptionThrowd = exceptionMap__.containsKey(threadInfo);
            if(isExceptionThrowd == true) 
            {
                //ĂOIuWFNg}bvoBi폜j
                Throwable exception = (Throwable)exceptionMap__.remove(threadInfo);
                
                // Catchڍ׃OB
                StringBuffer throwBuff = createThrowCatchDetail(CATCH, calleeMethodName,
                        calleeClassName, objectID, threadInfo, exception);

                // Catch OóB
                logger_.debug(throwBuff);
            }

            // Returnڍ׃OB
            StringBuffer returnDetailBuff = createReturnDetail(methodCallBuff, ret);

            // ReturnOóB
            logger_.debug(returnDetailBuff);

            this.callerLog_.set(currentCallerLog);
        }

        try
        {
            JmxRecorder.postProcess();
            S2StatsJavelinRecorder.postProcess(ret, this.config_);
        }
        catch(Throwable th)
        {
        	th.printStackTrace();
        }
        
        //invocationsۂ̖߂lԂB
        return ret;
    }

    /**
     * \bhĂяoiʎqCallj̏ڍׂȃO𐶐B
     * 
     * @param methodCallBuff \bhĂяo̕
     * @param invocation \bhĂяȍ
     * @return \bhĂяȍڍׂȃO
     */
    private StringBuffer createCallDetail(StringBuffer methodCallBuff,
            MethodInvocation invocation)
    {
        String timeStr = ((SimpleDateFormat) this.timeFormat_.get())
                .format(new Date());
        StringBuffer callDetailBuff = new StringBuffer(512);

        callDetailBuff.append(CALL);
        callDetailBuff.append(DELIM);
        callDetailBuff.append(timeStr);
        callDetailBuff.append(DELIM);
        callDetailBuff.append(methodCallBuff);

        // ̃O𐶐B
        if (this.isLogArgs_ == true)
        {
            callDetailBuff.append("<<javelin.Args_START>>" + NEW_LINE);
            Object[] args = invocation.getArguments();
            if (args != null && args.length > 0)
            {
                for (int i = 0; i < args.length; ++i)
                {
                    callDetailBuff.append("    args[");
                    callDetailBuff.append(i);
                    callDetailBuff.append("] = ");
                    callDetailBuff.append(args[i]);
                    callDetailBuff.append(NEW_LINE);
                }
            }
            callDetailBuff.append("<<javelin.Args_END>>" + NEW_LINE);
        }

        // X^bNg[X̃O𐶐B
        if (this.isLogStackTrace_ == true)
        {
            callDetailBuff.append("<<javelin.StackTrace_START>>" + NEW_LINE);
            Throwable th = new Throwable();
            StackTraceElement[] stackTraceElements = th.getStackTrace();
            for (int index = CALLER_STACKTRACE_INDEX; index < stackTraceElements.length; index++)
            {
                callDetailBuff.append("    at ");
                callDetailBuff.append(stackTraceElements[index]);
                callDetailBuff.append(NEW_LINE);
            }

            callDetailBuff.append("<<javelin.StackTrace_END>>" + NEW_LINE);
        }

        if (invocation.getThis() instanceof Throwable)
        {
            callDetailBuff.append("<<javelin.Exception>>" + NEW_LINE);
        }
        return callDetailBuff;
    }

    /**
     * \bh̖߂iʎqReturnj̏ڍׂȃO𐶐B
     * 
     * @param methodCallBuff \bhĂяo̕
     * @param ret \bh̖߂l
     * @return \bh̖߂̏ڍׂȃO
     */
    private StringBuffer createReturnDetail(StringBuffer methodCallBuff,
            Object ret)
    {
        StringBuffer returnDetailBuff = new StringBuffer(512);
        String returnTimeStr = ((SimpleDateFormat) this.timeFormat_.get())
                .format(new Date());
        returnDetailBuff.append(RETURN);
        returnDetailBuff.append(DELIM);
        returnDetailBuff.append(returnTimeStr);
        returnDetailBuff.append(DELIM);
        returnDetailBuff.append(methodCallBuff);

        // ߂l̃O𐶐B
        if (this.isLogReturn_)
        {
            returnDetailBuff.append("<<javelin.Return_START>>" + NEW_LINE);
            returnDetailBuff.append("    ");
            returnDetailBuff.append(ret);
            returnDetailBuff.append(NEW_LINE);
            returnDetailBuff.append("<<javelin.Return_END>>" + NEW_LINE);
        }
        return returnDetailBuff;
    }

    /**
     * OiʎqThrowjA܂͗OLb`iCatchj̏ڍ׃O𐶐B
     * 
     * @param id ʎqBThrow܂Catch
     * @param calleeMethodName Ăяo惁\bh
     * @param calleeClassName ĂяoNX
     * @param objectID ĂяoNX̃IuWFNgID
     * @param threadInfo Xbh
     * @param cause O
     * @return ȌڍׂȃO
     */
    private StringBuffer createThrowCatchDetail(String id, String calleeMethodName,
            String calleeClassName, String objectID, String threadInfo,
            Throwable cause)
    {
        String throwTimeStr = ((SimpleDateFormat) this.timeFormat_.get())
                .format(new Date());
        String throwableID = Integer
                .toHexString(System.identityHashCode(cause));
        StringBuffer throwBuff = new StringBuffer(512);
        throwBuff.append(id);
        throwBuff.append(DELIM);
        throwBuff.append(throwTimeStr);
        throwBuff.append(DELIM);
        throwBuff.append(cause.getClass().getName());
        throwBuff.append(DELIM);
        throwBuff.append(throwableID);
        throwBuff.append(DELIM);
        throwBuff.append(calleeMethodName);
        throwBuff.append(DELIM);
        throwBuff.append(calleeClassName);
        throwBuff.append(DELIM);
        throwBuff.append(objectID);
        throwBuff.append(DELIM);
        throwBuff.append(threadInfo);
        return throwBuff;
    }

    /**
     * 
     * @param intervalMax
     */
    public void setIntervalMax(int intervalMax)
    {
        if (this.config_.isSetIntervalMax() == false)
        {
            this.config_.setIntervalMax(intervalMax);
        }
    }

    /**
     * 
     * @param throwableMax
     */
    public void setThrowableMax(int throwableMax)
    {
        if (this.config_.isSetThrowableMax() == false)
        {
            this.config_.setThrowableMax(throwableMax);
        }
    }

    /**
     * 
     * @param recordThreshold
     */
    public void setRecordThreshold(int recordThreshold)
    {
        if (this.config_.isSetRecordThreshold() == false)
        {
            this.config_.setRecordThreshold(recordThreshold);
        }
    }

    /**
     * 
     * @param alarmThreshold
     */
    public void setAlarmThreshold(int alarmThreshold)
    {
        if (this.config_.isSetAlarmThreshold() == false)
        {
            this.config_.setAlarmThreshold(alarmThreshold);
        }
    }

    /**
     * 
     * @param domain
     */
    public void setDomain(String domain)
    {
        if (this.config_.isSetDomain() == false)
        {
            this.config_.setDomain(domain);
        }
    }

    /**
     * StatsJavelinOo͂fBNgw肷B
     *
     * @param javelinFileDir fBNg
     */
    public void setJavelinFileDir(String javelinFileDir)
    {
        if (this.config_.isSetJavelinFileDir() == false)
        {
            this.config_.setJavelinFileDir(javelinFileDir);
        }
    }
    
    /**
     * 
     * @param httpPort
     */
    public void setHttpPort(int httpPort)
    {
        if (this.config_.isSetHttpPort() == false)
        {
            this.config_.setHttpPort(httpPort);
        }
    }

    /**
     * o͂邩ǂ̐ݒύXB
     *
     * @param isLogArgs o͂Ȃtrue
     */
    public void setLogArgs(boolean isLogArgs)
    {
        if (this.config_.isLogArgs() == false)
        {
            this.config_.setLogArgs(isLogArgs);
        }
    }

    /**
     * ߂lo͂邩ǂ̐ݒύXB
     *
     * @param isLogReturn ߂lo͂Ȃtrue
     */
    public void setLogReturn(boolean isLogReturn)
    {
        if (this.config_.isLogReturn() == false)
        {
            this.config_.setLogArgs(isLogReturn);
        }
    }

    /**
     * X^bNg[Xo͂邩ǂ̐ݒύXB
     *
     * @param isLogStacktrace X^bNg[Xo͂Ȃtrue
     */
    public void setLogStacktrace(boolean isLogStacktrace)
    {
        if (this.config_.isLogStacktrace() == false)
        {
            this.config_.setLogStacktrace(isLogStacktrace);
        }
    }

    /**
     * 
     * @param endCalleeName
     */
	public void setEndCalleeName(String endCalleeName)
	{
        if (this.config_.isSetEndCalleeName() == false)
        {
            this.config_.setEndCalleeName(endCalleeName);
        }
	}

    /**
     * 
     * @param endCallerName
     */
	public void setRootCallerName(String endCallerName)
	{
        if (this.config_.isSetRootCallerName() == false)
        {
            this.config_.setRootCallerName(endCallerName);
        }
	}

    /**
     * 
     * @param threadModel
     */
	public void setThreadModel(int threadModel)
	{
        if (this.config_.isSetThreadModel() == false)
        {
            this.config_.setThreadModel(threadModel);
        }
	}


    /**
     * ݒlWo͂ɏo͂B
     */
    private void printConfigValue()
    {
        PrintStream out = System.out;
        out.println(">>>> Properties related with S2JavelinInterceptor");
        out.println("\tjavelin.javelinEnable   : " + this.config_.isJavelinEnable());
        out.println("\tjavelin.intervalMax     : " + this.config_.getIntervalMax());
        out.println("\tjavelin.throwableMax    : " + this.config_.getThrowableMax());
        out.println("\tjavelin.recordThreshold : " + this.config_.getRecordThreshold());
        out.println("\tjavelin.alarmThreshold  : " + this.config_.getAlarmThreshold());
        out.println("\tjavelin.domain          : " + this.config_.getDomain());
        out.println("\tjavelin.httpPort        : " + this.config_.getHttpPort());
        out.println("<<<<");
    }
}