package org.seasar.javelin;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

/**
 * JaveliñOt@CǗ
 * 
 * @author fujii
 * 
 */
public class S2StatsJavelinFileGenerator
{
    private static String javelinFileDir_ = "";
    
    /** t@CɂV[PXio[ */
    private static int sequenceNumber = 0;

    /**
     * JaveliñOt@CۑfBNgݒ肷
     * 
     * @param javelinFielDir
     *            t@C݂̑fBNg
     */
    public S2StatsJavelinFileGenerator(String javelinFielDir)
    {
        javelinFileDir_ = javelinFielDir;
    }

    /**
     * JavelinOƂāAt@Cɏo͂B
     * 
     * @param tree
     * @param node
     */
    public void generateJaveinFile(CallTree tree, CallTreeNode node)
    {
        Writer writer = null;
        try
        {
            String jvnFileName = createJvnFileDir();
            writer = new FileWriter(jvnFileName, true);

            // ċAIwriterɏ݂sB
            generateJavelinFileImpl(writer, tree, node);
        }
        catch (IOException ioe)
        {
            ioe.printStackTrace();
        }
        finally
        {
            if (writer != null)
            {
                try
                {
                    writer.close();
                }
                catch (IOException ioe)
                {
                    ioe.printStackTrace();
                }
            }
        }
    }

    /**
     * t@C𐶐
     * @return t@C
     */
    private String createJvnFileDir( )
    {
        /** ttH[}bg(~(sec)܂ŕ\) */
        SimpleDateFormat jvnFileFormat = new SimpleDateFormat(
                "yyyyMMddHHmmssSSS");
        String fileName = "";

        fileName = javelinFileDir_ + File.separator + "javelin_"
                + jvnFileFormat.format(new Date()) + "_"
                + Integer.toString(sequenceNumber) + ".jvn";

        sequenceNumber++;
        return fileName;
    }

    /**
     * JavelinOƂāAt@Cɏo͂B
     * @param writer C^[
     * @param tree O̊Kw
     * @param node
     */
    public static void generateJavelinFileImpl(Writer writer, CallTree tree,
            CallTreeNode node)
    {
    	String jvnCallMessage;
    	if (node.isFieldAccess())
    	{
            jvnCallMessage = JavelinLogMaker.createJavelinLog(
                    JavelinLogMaker.ID_READ, node.getStartTime(), tree, node);
    	}
    	else
    	{
            jvnCallMessage = JavelinLogMaker.createJavelinLog(
                    JavelinLogMaker.ID_CALL, node.getStartTime(), tree, node);
    	}

        // t@C1bZ[WށB
        try
        {
        	if (jvnCallMessage != null)
        	{
                writer.write(jvnCallMessage);
        	}
        }
        catch (IOException ioe)
        {
            ioe.printStackTrace();
        }

        List children = node.getChildren();
        for (int index = 0; index < children.size(); index++)
        {
            CallTreeNode child = (CallTreeNode) children.get(index);
            generateJavelinFileImpl(writer, tree, child);
        }

        // ThrowOށB
        if(node.getThrowable() != null)
        {
            writeThrowLog(writer, tree, node);
        }
        
        String jvnReturnMessage;
        if (node.isFieldAccess())
        {
            jvnReturnMessage = JavelinLogMaker.createJavelinLog(
                    JavelinLogMaker.ID_WRITE, node.getEndTime(), tree, node);
        }
        else
        {
            jvnReturnMessage = JavelinLogMaker.createJavelinLog(
                    JavelinLogMaker.ID_RETURN, node.getEndTime(), tree, node);
        }
        
        // t@C1bZ[WށB
        try
        {
        	if (jvnReturnMessage != null)
        	{
                writer.write(jvnReturnMessage);
        	}
        }
        catch (IOException ioe)
        {
            ioe.printStackTrace();
        }
    }

    private static void writeThrowLog(Writer writer, CallTree tree, CallTreeNode node)
    {
        String jvnThrowMessage = JavelinLogMaker.createJavelinLog(
                                                            JavelinLogMaker.ID_THROW, node.getThrowTime(), tree, node);
        
        // t@C1bZ[WށB
        try
        {
            if (jvnThrowMessage != null)
            {
                writer.write(jvnThrowMessage);
            }
        }
        catch (IOException ioe)
        {
            ioe.printStackTrace();
        }
    }

}
