package org.seasar.javelin.communicate;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.nio.ByteBuffer;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import org.seasar.javelin.MBeanManager;
import org.seasar.javelin.bean.Component;
import org.seasar.javelin.bean.Invocation;
import org.seasar.javelin.communicate.entity.Header;
import org.seasar.javelin.communicate.entity.ResponseBody;
import org.seasar.javelin.communicate.entity.Telegram;


/**
 * {Iȋʋ@\񋟂
 */
public final class TelegramUtil extends Common {
	private static final String CLASSMETHOD_SEPARATOR = "###CLASSMETHOD_SEPARATOR###";
    private static final int TELEGRAM_ITEM_COUNT = 6;

	/**
	 * String  byte[size,data] ɓ]
	 */
	public static byte[] strToByteArr(String strBodyData) {
		// String  byte[data] ɓ]
		byte[] byteBodyDataArr;
		try {
			byteBodyDataArr = strBodyData.getBytes("UTF-8");
		} catch (UnsupportedEncodingException e) {
			return new byte[0];
		}

		ByteBuffer buffer = ByteBuffer.allocate(byteBodyDataArr.length
				+ INT_BYTE_SWITCH_LENGTH);
		buffer.putInt(byteBodyDataArr.length);
		buffer.put(byteBodyDataArr);

		return buffer.array();
	}

	/**
	 * byte[size,data]  String ɓ]
	 */
	public static String byteArrToStr(ByteBuffer buffer) {
		// ԋpp
		String strResult = "";

		// size 擾
		int intbyteArrLength = buffer.getInt();

		try {
			byte[] byteSoruceArr = new byte[intbyteArrLength];
			buffer.get(byteSoruceArr);

			// byte[data]  String ɕϊ
			strResult = new String(byteSoruceArr, 0, intbyteArrLength, "UTF-8");
		} catch (UnsupportedEncodingException uee) {
			return "";
		}

		// ԋp
		return strResult;
	}

	/**
	 * d́Aobject  byte[] ɕϊ
	 */
	public static byte[] createTelegram(Telegram telegram) {
		// f[^o͗ɐݒ肷
		byte[] byteHeadArr = new byte[6];
		byteHeadArr[TelegramUtil.INT_BYTE_SWITCH_LENGTH] = telegram
				.getObjHeader().getByteTelegramKind();
		byteHeadArr[TelegramUtil.INT_BYTE_SWITCH_LENGTH + 1] = telegram
				.getObjHeader().getByteRequestKind();

		if (telegram.getObjBody() == null) {
			setLength(byteHeadArr);
			return byteHeadArr;
		}

		// {̃f[^
		ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();
		try {
			byteArrayOutputStream.write(byteHeadArr);

			for (int i = 0; i < telegram.getObjBody().length; i++) {
				ResponseBody responseBody = (ResponseBody) telegram
						.getObjBody()[i];
				// IuWFNg  byte[size,data] ɓ]
				byte[] byteBodyObjNameArr = TelegramUtil
						.strToByteArr(responseBody.getStrObjName());
				byteArrayOutputStream.write(byteBodyObjNameArr);

				// ږ  byte[size,data] ɓ]
				byte[] byteBodyItemNameArr = TelegramUtil
						.strToByteArr(responseBody.getStrItemName());
				byteArrayOutputStream.write(byteBodyItemNameArr);

				// ڌ^  byte[size,data] ɓ]
				byte[] byteBodyItemModeArr = new byte[1];
				byteBodyItemModeArr[0] = responseBody.getByteItemMode();
				byteArrayOutputStream.write(byteBodyItemModeArr);

				// JԂ  byte[size,data] ɓ]
				ByteBuffer objByteBufferBodyLoopCount = ByteBuffer
						.allocate(INT_BYTE_SWITCH_LENGTH);
				objByteBufferBodyLoopCount.putInt(responseBody
						.getIntLoopCount());
				byte[] byteBodyLoopCount = objByteBufferBodyLoopCount.array();
				byteArrayOutputStream.write(byteBodyLoopCount);

				//   byte[size,data] ɓ]
				Object[] objItemValueArrTemp = (responseBody)
						.getObjItemValueArr();
				if (objItemValueArrTemp != null) {
					for (int j = 0; j < objItemValueArrTemp.length; j++) {
						if (responseBody.getByteItemMode() == 6) {
							byte[] byteItemValueArr;
							byteItemValueArr = TelegramUtil
									.strToByteArr(((Invocation) objItemValueArrTemp[j])
											.getClassName());
							byteArrayOutputStream.write(byteItemValueArr);
						} else {
							ByteBuffer objByteBufferItemValue = ByteBuffer
									.allocate(LONG_BYTE_SWITCH_LENGTH);
							objByteBufferItemValue
									.putLong(((Long) objItemValueArrTemp[j])
											.longValue());
							byte[] byteItemValueArr = objByteBufferItemValue
									.array();
							byteArrayOutputStream.write(byteItemValueArr);
						}
					}

				}
			}
		} catch (IOException ioe) {
			// ȂB
		}
		byte[] byteOutputArr = byteArrayOutputStream.toByteArray();
		setLength(byteOutputArr);

		// ԋp
		return byteOutputArr;
	}

	private static void setLength(byte[] byteOutputArr) {
		// ϊNXg
		ByteBuffer objByteBuffer = ByteBuffer.allocate(INT_BYTE_SWITCH_LENGTH);
		objByteBuffer.putInt(byteOutputArr.length);

		// dTCY擾āAo͗̍ŏƂɐݒ肷
		byte[] byteHeadSizeArr = objByteBuffer.array();
		for (int i = 0; i < byteHeadSizeArr.length; i++) {
			byteOutputArr[i] = byteHeadSizeArr[i];
		}
	}

	/**
	 * d́Abyte[]  object ɉ񕜂 TODO ERIGUCHI Sdʂɂ͑ΉĂȂB
	 */
	public static Telegram recoveryTelegram(byte[] byteTelegramArr) {
		// ԋpp
		Telegram objTelegram = new Telegram();

		if (byteTelegramArr == null)
			return null;

		ByteBuffer telegramBuffer = ByteBuffer.wrap(byteTelegramArr);

		// ܂AHeader擾
		Header objHeader = new Header();
		objHeader.setIntSize(telegramBuffer.getInt());
		objHeader.setByteTelegramKind(telegramBuffer.get());
		objHeader.setByteRequestKind(telegramBuffer.get());

		// dɒučő͘Z{̂
		ResponseBody[] objResponseBodyArrTemp = new ResponseBody[6];
		// {d̒Ŏۖ{̐v
		int intBodyCounter = 0;

		// {̂擾
		while (telegramBuffer.remaining() > 0) {
			// {̑Ώۂ
			objResponseBodyArrTemp[intBodyCounter] = new ResponseBody();

			// IuWFNgݒ
			objResponseBodyArrTemp[intBodyCounter]
					.setStrObjName(byteArrToStr(telegramBuffer));

			// ږݒ
			objResponseBodyArrTemp[intBodyCounter]
					.setStrItemName(byteArrToStr(telegramBuffer));

			// ڌ^ݒ
			objResponseBodyArrTemp[intBodyCounter]
					.setByteItemMode(telegramBuffer.get());

			// JԂ񐔐ݒ
			objResponseBodyArrTemp[intBodyCounter]
					.setIntLoopCount(telegramBuffer.getInt());

			// ݒ
			Object[] values = new Object[objResponseBodyArrTemp[intBodyCounter]
					.getIntLoopCount()];
			for (int index = 0; index < values.length; index++) {
				if (objResponseBodyArrTemp[intBodyCounter].getByteItemMode() == BYTE_ITEMMODE_KIND_STRING) {
					// ڌ^BYTE_ITEMMODE_KIND_STRING̏ꍇAString[] 擾
					values[index] = byteArrToStr(telegramBuffer);
				} else {
					// ڌ^BYTE_ITEMMODE_KIND_STRINGȊȌꍇALong 擾
					values[index] = Long.valueOf(telegramBuffer.getLong());
				}
			}

			objResponseBodyArrTemp[intBodyCounter].setObjItemValueArr(values);
			// {̐L^
			intBodyCounter++;
		}

		// {̃Xg
		ResponseBody[] objResponseBodyArr = new ResponseBody[intBodyCounter];
		System.arraycopy(objResponseBodyArrTemp, 0, objResponseBodyArr, 0,
				intBodyCounter);

		// 񕜂Ɩ{̂dɐݒ肷
		objTelegram.setObjHeader(objHeader);
		objTelegram.setObjBody(objResponseBodyArr);

		// ԋp
		return objTelegram;
	}

	/**
	 * do͂
	 */
	public static String printTelegram(int intCounter, Telegram objInputTelegram) {
		StringBuffer buffer = new StringBuffer();
		buffer.append("\n***** " + intCounter + "ԖړdJn *****\n");
		buffer
				.append("#wb_d : "
						+ objInputTelegram.getObjHeader().getIntSize());
		buffer.append("\n");
		buffer.append("#wb_d : "
				+ objInputTelegram.getObjHeader().getByteTelegramKind());
		buffer.append("\n");
		buffer.append("#wb_ : "
				+ objInputTelegram.getObjHeader().getByteRequestKind());
		buffer.append("\n");

		for (int i = 0; i < objInputTelegram.getObjBody().length; i++) {
			buffer.append("------------------");
			buffer.append("\n");
			buffer.append("--{["
					+ i
					+ "]Ώۖ@ : "
					+ ((ResponseBody) objInputTelegram.getObjBody()[i])
							.getStrObjName());
			buffer.append("\n");
			buffer.append("--{["
					+ i
					+ "]ږ@ : "
					+ ((ResponseBody) objInputTelegram.getObjBody()[i])
							.getStrItemName());
			buffer.append("\n");
			buffer.append("--{["
					+ i
					+ "]ڌ^@ : "
					+ ((ResponseBody) objInputTelegram.getObjBody()[i])
							.getByteItemMode());
			buffer.append("\n");
			buffer.append("--{["
					+ i
					+ "]Jԉ : "
					+ ((ResponseBody) objInputTelegram.getObjBody()[i])
							.getIntLoopCount());
			buffer.append("\n");
			Object[] objArr = ((ResponseBody) objInputTelegram.getObjBody()[i])
					.getObjItemValueArr();
			for (int j = 0; j < objArr.length; j++) {
				buffer.append("--{[" + i + "]@@ : [" + j + "]" + objArr[j]);
				buffer.append("\n");
			}
		}
		buffer.append("***** " + intCounter + "ԖړdI *****");
		buffer.append("\n");

		return buffer.toString();
	}

	public static byte[] createAll() {
		// df[^
		Component[] objComponentArr = MBeanManager.getAllComponents();
		List invocationList = new ArrayList();

		// d𓝌v
		for (int i = 0; i < objComponentArr.length; i++) {
			invocationList.addAll(Arrays.asList((Object[]) objComponentArr[i]
					.getAllInvocation()));
		}

		Telegram objTelegram = TelegramUtil.create(invocationList,
				Common.BYTE_TELEGRAM_KIND_GET,
				Common.BYTE_REQUEST_KIND_RESPONSE);

		// d́Aobject  byte[] ɕϊ
		byte[] result = createTelegram(objTelegram);

		// ԋp
		return result;
	}

	// public static byte[] createAll() {
	// // df[^
	// Component[] objComponentArr = MBeanManager.getAllComponents();
	// Invocation[] objInvocationArr;
	//
	// // d𓝌v
	// int intTelegramCount = 0;
	// for (int i = 0; i < objComponentArr.length; i++) {
	// objInvocationArr = objComponentArr[i].getAllInvocation();
	// for (int j = 0; j < objInvocationArr.length; j++) {
	// intTelegramCount++;
	// }
	// }
	//
	// // dXg
	// Telegram[] objTelegramArr = new Telegram[intTelegramCount];
	//
	// // df[^ݒ肷
	// int intTelegramIndex = 0;
	// for (int i = 0; i < objComponentArr.length; i++) {
	// objInvocationArr = objComponentArr[i].getAllInvocation();
	// for (int j = 0; j < objInvocationArr.length; j++) {
	// Invocation invocation = objInvocationArr[j];
	//
	// Telegram objTelegram = TelegramUtil.create(invocation,
	// Common.BYTE_TELEGRAM_KIND_GET,
	// Common.BYTE_REQUEST_KIND_RESPONSE);
	// objTelegramArr[intTelegramIndex] = objTelegram;
	// intTelegramIndex++;
	// }
	// }
	//
	// // d́Aobject  byte[] ɕϊ
	// ByteArrayOutputStream byteArrayOutputStream = new
	// ByteArrayOutputStream();
	// try {
	// for (int i = 0; i < objTelegramArr.length; i++) {
	// byteArrayOutputStream.write(createTelegram(objTelegramArr[i]));
	// }
	// } catch (IOException e) {
	// // ȂB
	// }
	//
	// // ԋp
	// return byteArrayOutputStream.toByteArray();
	// }
	static Telegram create(List invocations, byte telegramKind, byte requestKind) {
		// dyƂ肠Adݒ肵Ȃz
		Header objHeader = new Header();
		objHeader.setByteRequestKind(requestKind);
		objHeader.setByteTelegramKind(telegramKind);

		// d{̂
		ResponseBody[] bodies = new ResponseBody[invocations.size()
				* TELEGRAM_ITEM_COUNT];

		for (int index = 0; index < invocations.size(); index++) {
			Invocation invocation = (Invocation) invocations.get(index);

			// IuWFNg擾
			StringBuffer strObjName = new StringBuffer();
			strObjName.append(invocation.getClassName());
			strObjName.append(CLASSMETHOD_SEPARATOR);
			strObjName.append(invocation.getMethodName());
			// ڐu郊Xg
			Object[] objItemValueArr = null;
			int bodyIndex = index * TELEGRAM_ITEM_COUNT;
			// Ăяo
			bodies[bodyIndex + 0] = new ResponseBody();
			bodies[bodyIndex + 0].setStrObjName(strObjName.toString());
			bodies[bodyIndex + 0].setStrItemName("callCount");
			bodies[bodyIndex + 0]
					.setByteItemMode(Common.BYTE_ITEMMODE_KIND_8BYTE_INT);
			bodies[bodyIndex + 0].setIntLoopCount(Common.INT_LOOP_COUNT_SINGLE);
			objItemValueArr = new Long[1];
			objItemValueArr[0] = Long.valueOf(invocation.getCount());
			bodies[bodyIndex + 0].setObjItemValueArr(objItemValueArr);
			// ώ
			bodies[bodyIndex + 1] = new ResponseBody();
			bodies[bodyIndex + 1].setStrObjName(strObjName.toString());
			bodies[bodyIndex + 1].setStrItemName("averageInterval");
			bodies[bodyIndex + 1]
					.setByteItemMode(Common.BYTE_ITEMMODE_KIND_8BYTE_INT);
			bodies[bodyIndex + 1].setIntLoopCount(Common.INT_LOOP_COUNT_SINGLE);
			objItemValueArr = new Long[1];
			objItemValueArr[0] = Long.valueOf(invocation.getAverage());
			bodies[bodyIndex + 1].setObjItemValueArr(objItemValueArr);
			// ő又
			bodies[bodyIndex + 2] = new ResponseBody();
			bodies[bodyIndex + 2].setStrObjName(strObjName.toString());
			bodies[bodyIndex + 2].setStrItemName("maximumInterval");
			bodies[bodyIndex + 2]
					.setByteItemMode(Common.BYTE_ITEMMODE_KIND_8BYTE_INT);
			bodies[2].setIntLoopCount(Common.INT_LOOP_COUNT_SINGLE);
			objItemValueArr = new Long[1];
			objItemValueArr[0] = Long.valueOf(invocation.getMaximum());
			bodies[bodyIndex + 2].setObjItemValueArr(objItemValueArr);
			// ŏ
			bodies[bodyIndex + 3] = new ResponseBody();
			bodies[bodyIndex + 3].setStrObjName(strObjName.toString());
			bodies[bodyIndex + 3].setStrItemName("minimumInterval");
			bodies[bodyIndex + 3]
					.setByteItemMode(Common.BYTE_ITEMMODE_KIND_8BYTE_INT);
			bodies[bodyIndex + 3].setIntLoopCount(Common.INT_LOOP_COUNT_SINGLE);
			objItemValueArr = new Long[1];
			objItemValueArr[0] = Long.valueOf(invocation.getMinimum());
			bodies[bodyIndex + 3].setObjItemValueArr(objItemValueArr);
			// O
			bodies[bodyIndex + 4] = new ResponseBody();
			bodies[bodyIndex + 4].setStrObjName(strObjName.toString());
			bodies[bodyIndex + 4].setStrItemName("throwableCount");
			bodies[bodyIndex + 4]
					.setByteItemMode(Common.BYTE_ITEMMODE_KIND_8BYTE_INT);
			bodies[bodyIndex + 4].setIntLoopCount(Common.INT_LOOP_COUNT_SINGLE);
			objItemValueArr = new Long[1];
			objItemValueArr[0] = Long.valueOf(invocation.getThrowableCount());
			bodies[bodyIndex + 4].setObjItemValueArr(objItemValueArr);
			// \bȟĂяo NX
			bodies[bodyIndex + 5] = new ResponseBody();
			bodies[bodyIndex + 5].setStrObjName(strObjName.toString());
			bodies[bodyIndex + 5].setStrItemName("allCallerNames");
			bodies[bodyIndex + 5]
					.setByteItemMode(Common.BYTE_ITEMMODE_KIND_STRING);
			objItemValueArr = invocation.getAllCallerInvocation();
			bodies[bodyIndex + 5].setIntLoopCount(objItemValueArr.length);
			bodies[bodyIndex + 5].setObjItemValueArr(objItemValueArr);
		}

		// dIuWFNgݒ肷
		Telegram objTelegram = new Telegram();
		objTelegram.setObjHeader(objHeader);
		objTelegram.setObjBody(bodies);
		return objTelegram;
	}
}