package org.seasar.javelin.util;

import org.seasar.javelin.CallTreeNode;
import org.seasar.javelin.S2JavelinConfig;

import java.lang.reflect.AccessibleObject;
import java.lang.reflect.Array;
import java.lang.reflect.Field;
import java.lang.reflect.Modifier;
import java.util.Collection;
import java.util.Map;

public class StatsUtil
{

	public static long getElapsedTime(CallTreeNode node)
	{
	    long elapsedTime = node.getAccumulatedTime();
	    for (int index = 0; index < node.getChildren().size(); index++)
	    {
	    	CallTreeNode child = (CallTreeNode)  node.getChildren().get(index);
	        elapsedTime = elapsedTime - child.getAccumulatedTime();
	    }
	
	    return elapsedTime;
	}

	/**
	 * Xbhʂ邽߂̕o͂B 
	 * tH[}bgFXbh@XbhNX@XbhIuWFNgID
	 * 
	 * @return Xbhʂ邽߂̕
	 */
	public static String createThreadIDText( )
	{
	    Thread currentThread = Thread.currentThread();
	
	    StringBuffer threadId = new StringBuffer();
	    threadId.append(currentThread.getName());
	    threadId.append("@" + currentThread.getClass().getName());
	    threadId.append("@" + StatsUtil.getObjectID(currentThread));
	
	    return threadId.toString();
	}

	/**
	 * IuWFNgID16i`̕ƂĎ擾B
	 * 
	 * @param object IuWFNgID擾IuWFNgB
	 * @return IuWFNgIDB
	 */
	public static String getObjectID(Object object)
	{
	    // null̏ꍇ"null"ԂB
	    if (object == null)
	    {
	        return "null";
	    }
	
	    return Integer.toHexString(System.identityHashCode(object));
	}
	
	/**
	 * objecttoStringŕɕϊB
	 * 
	 * toStringŗOꍇ́A
	 * WG[o͂object̃NXƃX^bNg[Xo͂A
	 * NX@IuWFNgIDԂB
	 * 
	 * @param object
	 * @return
	 */
	public static String toStr(Object object) {
		// null̏ꍇ"null"ԂB
		if (object == null) {
			return "null";
		}

		String result;
		try {
			result = object.toString();
		} catch (Throwable th) {
			S2JavelinConfig config = new S2JavelinConfig();
			if(config.isDebug())
			{
				System.err.println("Javelin Exception "
						+ object.getClass().toString() + "#toString(): ");
				th.printStackTrace();
			}
			result = object.getClass().toString() + "@"
					+ StatsUtil.getObjectID(object);
		}
		return result;
	}


	/**
	 * objecttoStringŕɕϊAw蒷Ő؂B
	 * 
	 * toStringŗOꍇ́A
	 * WG[o͂object̃NXƃX^bNg[Xo͂A
	 * NX@IuWFNgIDԂB
	 * w蒷𒴂Ăꍇ͎w蒷Ő؂A"..."t^B
	 * 
	 * @param object 񉻑ΏۃIuWFNg
	 * @param length w蒷
	 * @return
	 */
	public static String toStr(Object object, int length) {
		// null̏ꍇ"null"ԂB
		if (object == null) {
			return "null";
		}

		String result;
		try {
			result = object.toString();
			if(length == 0) {
				result = "";
			} else  if(result.length() > length) {
				result = result.substring(0, length) + "...";
			}
		} catch (Throwable th) {
			S2JavelinConfig config = new S2JavelinConfig();
			if(config.isDebug())
			{
				System.err.println("Javelin Exception "
						+ object.getClass().toString() + "#toString(): ");
				th.printStackTrace();
			}
			result = object.getClass().toString() + "@"
					+ StatsUtil.getObjectID(object);
		}
		
		return result;
	}
	
	/**
	 * oCgbyte[length]:FFFF...`ɕϊAw蒷Ő؂B
	 * 
	 * @param binary oCi
	 * @return
	 */
	public static String toStr(byte binary) {
		String hex = Integer.toHexString(((int)binary) & 0xFF).toUpperCase();
		String result = "byte[1]:" + "00".substring(hex.length()) + hex;
		return result;
	}
	
	/**
	 * oCgbyte[length]:FFFF...`ɕϊ(őŐ擪8oCg16io)B
	 * 
	 * @param binary oCi
	 * @return
	 */
	public static String toStr(byte[] binary) {
		
		if(binary.length == 0) {
			return "byte[0]";
		}
		
		StringBuffer result = new StringBuffer("byte[");
		result.append(binary.length);
		result.append("]:");
		for(int count = 0; count < 8 && count < binary.length; count++) {
			String hex = Integer.toHexString(((int)binary[count]) & 0xFF).toUpperCase();
			result.append("00".substring(hex.length()) + hex);
		}
		if(binary.length > 8) {
			result.append("...");
		}
		return result.toString();
	}
    
    //####################################################################
    //#  ȉJavelinLogUtilɂLq Cꍇ͓ꂷ邱Ɓ #
    //####################################################################
    private static final String   VALUE_HEADER        = "[";

    private static final String   VALUE_FOOTER        = "]";

    private static final String   KEY_VALUE_SEPARATOR = " = ";

    private static final String   VALUE_SEPARATOR     = " , ";

    private static final String   DEFAULT_VALUE       = "????";

    private static final String   NULL_VALUE          = "null";

    private static final String INNER_CLASS_SEPARATOR_CHAR = "$";

    //o͑ΏۂƂNXQ
    private static final String[] PRINT_CLASS         = {"Short", "Integer",
            "Long", "String", "Boolean", "Byte", "Character", "Float", "Double"};

    /**
     * Object̏o͂s
     * ͂ꂽ[xɂ킹AtB[hH邩̏ŏo͂邩肷
     * 
     * @param object       o͑ΏۃIuWFNg
     * @param detailDepth  o͐[x
     * @param currentDepth ݐ[x
     * @return             o͌
     */
    public static String objectDetailPrinter(Object object, int detailDepth,
            int currentDepth)
    {

    	// String̏ꍇ͂̂܂܏o͂B
        if(object instanceof String)
        {
            return (String)object;
        }

        if (object == null)
        {
            return NULL_VALUE;
        }
        
        // 擪Ƀwb_ǉB
        String detailString = toDetailString(object, detailDepth, currentDepth);
        if(currentDepth == 0)
        {
            StringBuffer detailBuffer = new StringBuffer();
        	detailBuffer.append(object.getClass().toString() + "@" + getObjectID(object)).append(":");
        	detailBuffer.append(detailString);
        	return detailBuffer.toString();
        }
        else
        {
        	return detailString;
        }
    }

	private static String toDetailString(Object object, int detailDepth, int currentDepth) {
		//݂̊Kw̐[ݒlȏ̏ꍇAtoStrinǧʂԂ
        if (currentDepth >= detailDepth)
        {
        	return toStringPrinter(object);
        }

        //o͑ΏۂƂȂIuWFNg̏ꍇAtoStrinǧʂԂ
        if (isPrintTarget(object))
        {
            return toStringPrinter(object);
        }

        Class clazz = object.getClass();
        //z̏ꍇAz̊evfɑ΂Ĕs
        if (clazz.isArray())
        {
            return toStringArrayObject(object, detailDepth, currentDepth);
        }
        //RNV̏ꍇAzɕϊĔs
        if (object instanceof Collection)
        {
            Collection collectionObject = (Collection)object;
            return toStringArrayObject(collectionObject.toArray(), detailDepth,
                                       currentDepth);
        }
        //Map̏ꍇ͐pŏo͂s
        if (object instanceof Map)
        {
            Map mapObject = (Map)object;
            return toStringMapObject(mapObject, detailDepth, currentDepth);
        }

        Field[] fields = clazz.getDeclaredFields();
        try
        {
            AccessibleObject.setAccessible(fields, true);
        }
        catch (SecurityException scex)
        {
            return toStringPrinter(object);
        }

        StringBuffer buf = new StringBuffer();
        buf.append(VALUE_HEADER);
        boolean separatorFlag = false;
        for (int i = 0; i < fields.length; i++)
        {
            Field field = fields[i];
            if (accept(field))
            {
                if (separatorFlag)
                {
                    buf.append(VALUE_SEPARATOR);
                }
                String fieldName = field.getName();
                buf.append(fieldName).append(KEY_VALUE_SEPARATOR);

                Object fieldValue = null;
                try
                {
                    fieldValue = field.get(object);
                    buf.append(objectDetailPrinter(fieldValue, detailDepth,
                                                   currentDepth + 1));

                }
                //G[ꍇ̓ftHgƂ
                catch (IllegalAccessException iaex)
                {
                    buf.append(DEFAULT_VALUE);
                }
                separatorFlag = true;
            }
        }
        buf.append(VALUE_FOOTER);
        return buf.toString();
	}

    /**
     * Map̕o͂sB
     * [key1 = value1 , key2 = value2 ..... keyn = valuen]̌`ŏo͂
     * 
     * @param mapObject    ΏۂƂȂMap
     * @param detailDepth  o͐[x
     * @param currentDepth ݐ[x
     * @return             Map̕\
     */
    public static String toStringMapObject(Map mapObject, int detailDepth,
            int currentDepth)
    {
        StringBuffer buf = new StringBuffer();
        buf.append(VALUE_HEADER);

        Object[] keys = mapObject.keySet().toArray();
        int length = keys.length;

        for (int i = 0; i < length; i++)
        {
            if (i > 0)
            {
                buf.append(VALUE_SEPARATOR);
            }
            
            Object item = mapObject.get(keys[i]);
            buf.append(toStringPrinter(keys[i])).append(KEY_VALUE_SEPARATOR);

            if (item == null)
            {
                buf.append(NULL_VALUE);
            }
            else
            {
                buf.append(objectDetailPrinter(item, detailDepth,
                                               currentDepth + 1));
            }
        }

        buf.append(VALUE_FOOTER);
        return buf.substring(0);
    }

    /**
     * zIuWFNg̃Oo͂s
     * 
     * @param array        o͑Ώہizj
     * @param detailDepth  o͐[x
     * @param currentDepth ݐ[x
     * @return             o͕
     */
    public static String toStringArrayObject(Object array, int detailDepth,
            int currentDepth)
    {
        StringBuffer buf = new StringBuffer();
        buf.append(VALUE_HEADER);
        int length = Array.getLength(array);
        for (int i = 0; i < length; i++)
        {
            Object item = Array.get(array, i);
            if (i > 0)
            {
                buf.append(VALUE_SEPARATOR);
            }

            if (item == null)
            {
                buf.append(NULL_VALUE);
            }
            else
            {
                buf.append(objectDetailPrinter(item, detailDepth,
                                               currentDepth + 1));
            }
        }
        buf.append(VALUE_FOOTER);
        return buf.substring(0);
    }

    /**
     * ToStrinǧʂԂ
     * 
     * @param object ϊΏ
     * @return       ToStrinǧ
     */
    public static String toStringPrinter(Object object)
    {
        //toString͗O𔭐邱Ƃ邽߁A
        //"????"ƂԂ悤ɂB
        try
        {
            return object.toString();
        }
        catch (Throwable th)
        {
            return DEFAULT_VALUE;
        }
    }

    /**
     * fieldo͂邩A̔茋ʂԂ
     * 
     * @param field NX̃tB[h
     * @return      o͂邩ۂ
     */
    public static boolean accept(Field field)
    {
        if (field.getName().indexOf(INNER_CLASS_SEPARATOR_CHAR) != -1)
        {
            return false;
        }
        if (Modifier.isTransient(field.getModifiers()))
        {
            return false;
        }
        if (Modifier.isStatic(field.getModifiers()))
        {
            return false;
        }
        return true;
    }

    /**
     * o͑Ώۂ̃IuWFNgs
     * Primitive^A͂̃bp[NXo͑ΏۂƂȂ
     * 
     * @param object Ώ
     * @return       茋
     */
    public static boolean isPrintTarget(Object object)
    {
        Class clazz = object.getClass();

        if (clazz.isPrimitive())
        {
            return true;
        }

        String className = clazz.getSimpleName();

        for (String target : PRINT_CLASS)
        {
            if (target.equals(className))
            {
                return true;
            }
        }

        return false;
    }
}
